﻿package com  {

	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.events.*;
	
	import com.SongAlbum;
	import com.Scrollbar;
	
	import com.greensock.*;
	import com.greensock.easing.*;
	
	public class LyricsHandler {

		private var _dispatcher:EventDispatcher;

		private var _album:SongAlbum;

		private var _container:MovieClip;
		private var _trackTitleMC:MovieClip;
		private var _trackNumberMC:MovieClip;
		private var _lyricsMC:MovieClip;
		private var _maskMC:MovieClip;
		private var _scrollbarMC:Scrollbar;

		//Class constructor
		public function LyricsHandler(dispatcher_:EventDispatcher, album_, container_) {
			
			_dispatcher = dispatcher_ as EventDispatcher;
			_dispatcher.addEventListener(SongAlbum.SONG_CHANGE, update);
			
			_album = album_ as SongAlbum;
			_container = container_ as MovieClip;
	
			_trackTitleMC  = _container.lyricsTrackTitle1 as MovieClip;
			_trackNumberMC = _container.lyricsTrackNumber1 as MovieClip;
			_lyricsMC = _container.lyricsLyrics1 as MovieClip;
			_maskMC = _container.lyricsLyricsMask1 as MovieClip;
			
			_scrollbarMC = _container.lyricsScrollbar1 as Scrollbar;
			
			/* Give the Scrollbar an onScroll() function */
			_scrollbarMC.addOnScroll( lyricsOnScroll );
		
		}
		
		private function lyricsOnScroll(scrollPercentage:Number):void {
			var textBox:TextField = _lyricsMC.getChildAt(0) as TextField;
			var minOffset:Number = _maskMC.y;
			var maxOffset:Number = _maskMC.height - textBox.textHeight;
			//This function will recieve a 'percentage' value between 0 and 1
			//We need to map this value into the range [minOffset,maxOffset]
			_lyricsMC.y = minOffset + maxOffset * scrollPercentage;
		}
		
		private function update(e:Event = null) {
			
			/* Fade out the lyric content */
			TweenMax.allTo([_trackTitleMC,_trackNumberMC,_lyricsMC], 1.0, { alpha: 0, ease:Quint.easeOut, onComplete: updateAndShow });
			
			/* Update the lyric content */
			
			function updateAndShow():void {
				
				var songData = _album.getCurrentSongData();
				var trackTitle = songData.trackTitle;
				var trackNumber = songData.trackNumber;
				var lyrics = songData.lyrics;
				
				var trackTitleTextBox = _trackTitleMC.getChildAt(0) as TextField;
				var trackNumberTextBox = _trackNumberMC.getChildAt(0) as TextField;
				var lyricsTextBox = _lyricsMC.getChildAt(0)
				
				trackTitleTextBox.text = trackTitle;
				trackNumberTextBox.text = trackNumber.toString();
				lyricsTextBox.text = lyrics
				
				/* Fade in the lyric content */
				TweenLite.to(_trackTitleMC, 2, { alpha: 1.00, ease:Quint.easeOut });
				TweenLite.to(_trackNumberMC, 2, { alpha: 0.45, ease:Quint.easeOut });
				TweenLite.to(_lyricsMC, 2, { alpha: 0.85, ease:Quint.easeOut });
				
			}
			
		}

	}
	
}
